//
//  ViewGL.mm
//  StarGenerator
//
//  Created by song on 2016-02-25.
//  Copyright © 2016 song. All rights reserved.
//

#import "ViewGL.h"

@implementation ViewGL

@synthesize model;



///////////////////////////////////////////////////////////////////////////////
- (void)drawRect:(NSRect)dirtyRect
{
    [super drawRect:dirtyRect];
    if(!model)
        return;

    model->draw();
    [[self openGLContext] flushBuffer];
}



///////////////////////////////////////////////////////////////////////////////
- (void)reshape
{
    if(!model)
        return;

    NSRect rect = [self convertRectToBacking:[self bounds]];
    int width = (int)rect.size.width;
    int height = (int)rect.size.height;
    model->setWindowSize(width, height);
    [self setNeedsDisplay:YES];

    printf("OpenGL window is resized: %d x %d\n", width, height);
}



///////////////////////////////////////////////////////////////////////////////
// handle mouse events
- (void)mouseDown:(NSEvent*)event
{
    if(!model)
        return;
    
    NSPoint pos = [NSEvent mouseLocation];
    model->setMousePosition((int)pos.x, (int)-pos.y);
}

- (void)mouseUp:(NSEvent*)event
{
    if(!model)
        return;
    
    NSPoint pos = [NSEvent mouseLocation];
    model->setMousePosition((int)pos.x, (int)-pos.y);
}

- (void)rightMouseDown:(NSEvent*)event
{
    if(!model)
        return;
    
    NSPoint pos = [NSEvent mouseLocation];
    model->setMousePosition((int)pos.x, (int)-pos.y);
}

- (void)rightMouseUp:(NSEvent*)event
{
    if(!model)
        return;
    
    NSPoint pos = [NSEvent mouseLocation];
    model->setMousePosition((int)pos.x, (int)-pos.y);
}

- (void)mouseDragged:(NSEvent*)event
{
    if(!model)
        return;
    
    NSPoint pos = [NSEvent mouseLocation];
    model->rotateCamera((int)pos.x, (int)-pos.y);
    [self setNeedsDisplay:YES];
}

- (void)rightMouseDragged:(NSEvent*)theEvent
{
    if(!model)
        return;
    
    NSPoint pos = [NSEvent mouseLocation];
    model->zoomCamera((int)-pos.y);
    [self setNeedsDisplay:YES];
}

- (void)scrollWheel:(NSEvent*)event
{
    if(!model)
        return;
    
    NSPoint pos = [NSEvent mouseLocation];
    int delta = (int)[event deltaY];
    model->setMousePosition((int)pos.x, (int)-pos.y);
    model->zoomCamera((int)-pos.y + delta);
    [self setNeedsDisplay:YES];
}

@end
